CREATE OR ALTER procedure ADDSTAT (
    V_NUB_K char(10),
    V_SN_POL char(25),
    V_D_ZA date,
    V_VID_O char(1),
    V_M_OBSL char(1),
    V_D_P_USL date,
    V_SP1 char(10),
    V_SP2 char(10),
    V_D_OS char(7),
    V_D_RA char(7),
    V_TERR char(4),
    V_REZ_OB char(2),
    V_OGRN char(15),
    V_D_ZAPOL date,
    V_COMPANY char(4),
    V_NUMBER_IN_REPORT integer,
    V_ID_REPORT integer,
    V_K_MES varchar(11),
    V_MKOD char(6),
    V_DOST char(20),
    V_RMIS char(36),
    V_IDCASE integer,
    V_ST_REPEAT integer,
    V_SUMM numeric(18,2),
    V_REG_SUMM numeric(18,2),
    V_SN_INV char(1),
    V_INVAL char(1),
    V_MSE integer,
    V_D_UCH char(1),
    V_CEL_P char(1),
    V_XAR_Z char(1),
    V_ZAB_G char(1),
    V_DISP_D char(1),
    V_S_MEK numeric(12,2),
    V_VIB integer,
    V_NAME_F char(30),
    V_VID_POM integer,
    V_FOR_POM integer,
    V_IDSP integer,
    V_VPOLIS integer,
    V_DS_ONK integer,
    V_NPR_MO char(6),
    V_NPR_DATE date,
    V_SL char(2),
    V_ISH_L char(3),
    V_REZ_O_XML char(3),
    V_ENP char(16))
returns (
    ID_STATTALON integer)
as
BEGIN
    if (not EXISTS ( SELECT c_ogrn FROM lpu WHERE c_ogrn = :v_ogrn)) then
        select report.lpu_ogrn from report where id_report = :v_id_report into :v_ogrn;

    /* with foreign constraints checks  */
    ID_STATTALON = gen_id(gen_stattalon_id, 1);

    if (EXISTS ( SELECT id_report FROM report WHERE id_report = :v_id_report))    then
    begin

    INSERT INTO STATTALON(ID_STATTALON,
                          NUB_K,
                          SN_POL,
                          D_ZA,
                          VID_O,
                          M_OBSL,
                          CEL_P,
                          XAR_Z,
                          D_UCH,
                          D_P_USL,
                          SP1,
                          SP2,
                          D_OS,
                          D_RA,
                          TERR,
                          inval,
                          SN_INV,
                          REZ_OB,
                          OGRN,
                          D_ZAPOL,
                          COMPANY,
                          NUMBER_IN_REPORT,
                          ID_REPORT,
                          summ,
                          reg_summ,
                          was_child,
                          SUM_FSS,
                          K_MES,
                          ZAB_G,
                          POS_COUNT,
                          HEAL_DAYS,
                          DISP_D,
                          VIB,
                          MOD_YCH,
                          ME_AB,
                          MKOD,
                          OK_FIN,
                          YET,
                          age,
                          dost,
                          RMIS,
                          ID_CASE_RMIS,
                          S_SUM,
                          ST_REPEAT,
                          NAME_F,
                          VID_POM,
                          FOR_POM,
                          IDSP,
                          VPOLIS,
                          MSE,
                          DS_ONK,
                          NPR_MO,
                          NPR_DATE,
                          SL,
                          ISH_L,
                          REZ_O_XML,
                          ENP)
    VALUES(:ID_STATTALON,
           :v_NUB_K,
           :v_SN_POL,
           :v_D_ZA,
           :v_VID_O,
           :v_M_OBSL,
           :v_cel_p,
           :v_xar_z,
           :v_d_uch,
           :v_D_P_USL,
           :v_SP1,
           :v_SP2,
           :v_D_OS,
           :v_D_RA,
           :v_TERR,
           :v_inval,
           :v_sn_inv,
           :v_REZ_OB,
           :v_OGRN,
           :V_D_ZAPOL,
           :v_COMPANY,
           :v_NUMBER_IN_REPORT,
           :v_id_report,
           0,
           :v_reg_summ,
           -1,
           0,
           :v_k_mes,
           :v_zab_g,
           0,
           0,
           :v_disp_d,
           0,
           0,
           0,
           :V_MKOD,
           0,
           0,
           0,
           :v_dost,
           :v_rmis,
           :v_idcase,
           0,
           :v_st_repeat,
           :v_name_f,
           :v_vid_pom,
           :v_for_pom,
           :v_idsp,
           :v_vpolis,
           :v_mse,
           :v_ds_onk,
           :v_npr_mo,
           :v_npr_date,
           :v_sl,
           :v_ish_l,
           :v_rez_o_xml,
           :v_enp);
    end
        else ID_STATTALON = -1;
END
